local metadata = {
"## Interface:FS15 1.3",
"## Title: TriggerExtend",
"## Notes: Setzt/Aendert Werte in Triggers",
"## Author: HappyLooser",
"## Version: 0.61",
"## Date: 02.02.2015",
"## Update: 18.07.2015",
"## Web: no",
"## Info: Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt"
}

TriggerExtend = {};
TriggerExtendMP = true;
TriggerExtendMPUpdate = false;
local setSellMilk = false;
local pathSavegame;
local stationNames = "(TE)sell station names: ";
local stationUpdateNames = "";
local start = true;
local Xml;
local delay = 3600000;
local updateDay = 0;
local wait = 0;
local changeType = "";
local amountPDA = false;
local timer = false;
local hofSiloLoadTypes = "";
local hofSiloUnLoadTypes = "";
local test = true;
local updateMilk = true;
local clientSellMilk = false;
TriggerExtendSellXml = "";

local siloId = 0;
local updateSiloTrigger = true;

function TriggerExtendLoad()	
	print("---loading TriggerExtend v0.61 (by HappyLooser)---")	
	local path = getUserProfileAppPath();		
	local file = pathSavegame.."/triggerExtendSettings.xml";		
	if g_server ~= nil and g_client ~= nil then		
		local firstSave = false;
		if fileExists(file) then
			print("loading "..file.." for TriggerExtend settings");		
			Xml = loadXMLFile("triggerExtendSettings_XML", file, "Trigger");			
		else
			if not fileExists(pathSavegame.. "/careerSavegame.xml") then				
				firstSave = true;
				file = path.."/savegameBackup/triggerExtendSettings.xml";
			end;
			if firstSave then print("creating Temp "..file.." for TriggerExtend settings");end;
			if not firstSave then print("creating "..file.." for TriggerExtend settings");end;
			Xml = createXMLFile("triggerExtendSettings_XML", file, "Trigger");		
			setXMLString(Xml, "Trigger.SellTrigger.StationFreightYard", "wheat:0,silage:0.45,forage_mixing:0.8,deleteOld:false,pdaOn:milk water forage_mixing,pdaOff:klee klee_windrow,milk:1.45,sellMilk:false");
			setXMLString(Xml, "Trigger.HofSiloTrigger.HofSiloLoad01", "woodChips silage forage forage_mixing grass_windrow wheat_windrow");
			setXMLString(Xml, "Trigger.HofSiloTrigger.HofSiloUnLoad01", "silage forage forage_mixing grass_windrow wheat_windrow");
		end;
		saveXMLFile(Xml);	
		Xml = loadXMLFile("triggerExtendSettings_XML", file, "Trigger");
		if not firstSave then
			saveBackup(file, path);
		end;
	end;	
end;

function getSellTypes(self, sellTypes)	
	if sellTypes == nil or string.len(sellTypes) <= 2 then return false;end;	
	local types = Utils.splitString(",", sellTypes);
	if types == nil then return false;end;
	local sellPrice = "";
	local sellType = "";
	local deleteOld = false;
	local sellMilk = true;
	local pdaOn = "";
	local pdaOff = "";
	local sellStopTypes = "";
	--string.upper()
	local upperSellTypes = string.lower(sellTypes)
	if string.find(string.lower(sellTypes), "deleteold:true") then deleteOld = true;end;
	if string.find(string.lower(sellTypes), "sellmilk:false") then sellMilk = false;end;
	for k,v in pairs(types) do		
		local checkGK = string.lower(v);
		if string.find(checkGK, "deleteold:") == nil and string.find(checkGK, "sellmilk:") == nil and string.find(checkGK, "pdaon:") == nil and string.find(checkGK, "pdaoff:") == nil then			
			if string.find(v, ":") == nil then				
				if string.len(sellType) >= 2 then sellType = sellType.. " ".. v;end;
				if string.len(sellPrice) >= 1 then sellPrice = sellPrice.. " 0.25";end;
				if string.len(sellType) == 0 then sellType = sellType.. v;end;
				if string.len(sellPrice) == 0 then sellPrice = sellPrice.. "0.25";end;
			else
				local typeAndPrice = Utils.splitString(":", v);
				if typeAndPrice ~= nil then
					if tonumber(typeAndPrice[2]) == 0 then
						sellStopTypes = sellStopTypes.. typeAndPrice[1].. " ";						
					end;
					if string.len(sellType) >= 2 then sellType = sellType.. " ".. typeAndPrice[1];end;
					if string.len(sellType) == 0 then sellType = sellType.. typeAndPrice[1];end;	
					if string.len(sellPrice) >= 1 then sellPrice = sellPrice.. " ".. typeAndPrice[2];end;
					if string.len(sellPrice) == 0 then sellPrice = sellPrice.. typeAndPrice[2];end;
				end;				
			end;			
		end;
		if string.find(checkGK, "pdaon:") then
			local replacePDA = string.sub (v, 7);
			replacePDA = string.gsub(replacePDA, " ", ",");
			pdaOn = replacePDA.. ",";			
		end;
		if string.find(checkGK, "pdaoff:") then
			local replacePDA = string.sub (v, 8);
			replacePDA = string.gsub(replacePDA, " ", ",");
			pdaOff = replacePDA.. ",";			
		end;
	end;	
	return sellType, sellPrice, sellStopTypes, deleteOld, pdaOn, pdaOff, sellMilk
end;

function MilliSecondsToHours(sMilliSeconds)
	local nMilliSeconds = tonumber(sMilliSeconds)
	if nMilliSeconds == 0 then
	--return nil;
	return "00";
	else
	local nHours = string.format("%02.f", math.floor(nMilliSeconds/3600000));
	--local nMins = string.format("%02.f", math.floor(nMilliSeconds/60000 - (nHours*60000)));
	--local nSecs = string.format("%02.f", math.floor(nMilliSeconds/1000 - nHours*3600000 - nMins *60000));
	--local nMilliSecs = math.ceil(nMilliseconds - (nHours*3600000) - (nMins *60000) - (nSecs *1000))
	return nHours --..":"..nMins..":"..nSecs.."."--..nMilliSecs
	end
end

function TriggerExtend:loadMap(xmlFile)	
	local dir = g_currentMission.missionInfo:getSavegameDirectory(g_currentMission.missionInfo.savegameIndex);
	pathSavegame = dir;	
	TriggerExtendLoad();	
	if g_server ~= nil and g_client ~= nil then		
		synSellTriggers(true, false, nil);
	end;	
	self.setExtendTrigger = TriggerExtendSellXml;
	self.loginEvent = false;
end;

function TriggerExtend:deleteMap()
	TriggerExtendMP = true;
	TriggerExtendMPUpdate = false;
	wait = 0;
	changeType = "";
	TriggerExtendSellXml = "";
	timer = false;			
	setSellMilk = false;
	changeType = "";
	hofSiloLoadTypes = "";
	hofSiloUnLoadTypes = "";
	updateSiloTrigger = true;
	siloId = 0;
	updateMilk = true;
	amountPDA = false;	
end;

function TriggerExtend:mouseEvent(posX, posY, isDown, isUp, button)	
end;

function TriggerExtend:keyEvent(unicode, sym, modifier, isDown)		
end;

function TriggerExtend:updateTick(dt)				
end;

function TriggerExtend:update(dt)
	if amountPDA and not g_currentMission.missionDynamicInfo.isMultiplayer then
		if InputBinding.isPressed(InputBinding.TOGGLE_PDA) then		
			if g_currentMission.husbandries.cow ~= nil then			
				updateMilk = false;				
				local milkRobot = g_currentMission.husbandries.cow.fillLevelMilk;				
				g_currentMission:setSiloAmount(Fillable.FILLTYPE_MILK, milkRobot);				
			end;
		else			
			if g_currentMission.husbandries.cow ~= nil then	
				if not updateMilk then
					g_currentMission:setSiloAmount(Fillable.FILLTYPE_MILK, 0);
					updateMilk = true;					
				else
					local amountMilk = Utils.getNoNil(g_currentMission:getSiloAmount(Fillable.FILLTYPE_MILK),0);
					g_currentMission:setSiloAmount(Fillable.FILLTYPE_MILK, 0);
					local milkRobot = g_currentMission.husbandries.cow.fillLevelMilk;
					g_currentMission.husbandries.cow.fillLevelMilk = amountMilk+milkRobot;
				end;				
			end;			
		end;	
	end;	
	if setSellMilk then
		FSBaseMission.sellMilk = function(a,b,c)			
			return a,b,c
		end
	end
	if g_server == nil and TriggerExtendMP then		
		TriggerExtendMP = false;
		TriggerExtendEvent.sendEvent(self.setExtendTrigger, true);
	end;
	if not timer then		
		timer = true;
		wait = MilliSecondsToHours(g_currentMission.environment.dayTime)*delay;
		updateDay = g_currentMission.environment.currentDay;				
	end;		
	if timer and wait <= g_currentMission.environment.dayTime or updateDay ~= g_currentMission.environment.currentDay then		
		updateDay = g_currentMission.environment.currentDay		
		wait = MilliSecondsToHours(g_currentMission.environment.dayTime)*delay + delay;
		synSellTriggersHoursUpdate(true, false, nil);
	end;
end;

function TriggerExtend:draw(dt)
end;

function synSellTriggersHoursUpdate()	
	if string.len(changeType) >= 2 then		
		local changeTypeName = Utils.splitString(" ", changeType);
		for k,v in pairs(changeTypeName) do
			local typeAndPrice = Utils.splitString(":", v);
			local desc = Fillable.fillTypeNameToDesc[typeAndPrice[1]];
			if desc ~= nil then
				local oldHourPrice = Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice;
				if tonumber(oldHourPrice) == 0 then
					oldHourPrice = typeAndPrice[2];					
				end;
				local oldLiterPrice = Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter;				
				if tonumber(oldLiterPrice) == 0 then					
					Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter = oldHourPrice;					
				end;				
			end;
		end;		
	end	
end;

function synSellTriggers(isServer, isClient, sellTriggerNew)
	if start then				
		if isServer then
			print("Update TriggerExtend.......begin")
			if getXMLString(Xml, "Trigger.HofSiloTrigger.HofSiloLoad01") ~= nil then
				hofSiloLoadTypes = getXMLString(Xml, "Trigger.HofSiloTrigger.HofSiloLoad01")
				TriggerExtendSellXml = TriggerExtendSellXml .."HofSiloLoad01:" ..hofSiloLoadTypes ..";";
			end;
			local fruitLeng = Fillable.NUM_FILLTYPES;
			local fruitNames = "(TriggerExtend)fruit names(".. fruitLeng.. ") and prices: ";
			for i=1,Fillable.NUM_FILLTYPES do
				local desc = Fillable.fillTypeIndexToDesc[i];
				if desc ~= nil then
					local name = desc.name;
					local fruitName = desc.name;
					if g_i18n:hasText(desc.nameI18N) then
						fruitName = g_i18n:getText(desc.nameI18N);
					else
						fruitName = desc.nameI18N
					end
					local price = 0;
					local pricePerLiter = Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter;
					if pricePerLiter == nil then								
						pricePerLiter = 0;								
					end;
					local pricePerHour = Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice;
					if pricePerHour == nil then								
						pricePerHour = 0;								
					end;
					if tonumber(pricePerLiter) ~= tonumber(pricePerHour) then
						pricePerLiter = pricePerHour;
					end;
					local difficultyMultiplier = math.max(2 * (3 - g_currentMission.missionStats.difficulty), 1);
					local formatTemp = string.format("%1.2f", "".. pricePerLiter*difficultyMultiplier);
					fruitNames = fruitNames.. name.. "(".. formatTemp.. ")".. "(InGame=".. tostring(fruitName).. "),";
				end;
			end;			
			print(fruitNames)						
		end;		
		if isClient and sellTriggerNew ~= nil then
			print("Server File Update TriggerExtend.......begin")
			if string.find(sellTriggerNew, "HofSiloLoad01:") ~= nil then
				local serverTriggers = Utils.splitString(";", sellTriggerNew);							
				for k,v in pairs(serverTriggers) do
					if string.find(v, "HofSiloLoad01:") ~= nil then
						serverTriggers = string.gsub(v, "HofSiloLoad01:", "")										
						stationUpdateNames = stationUpdateNames.. " HofSiloLoad01";
						hofSiloLoadTypes = serverTriggers;
						break;
					end;
				end;
			end;
		end;
		if string.len(hofSiloLoadTypes) <= 2 then			
			updateSiloTrigger = false
		else
			if g_currentMission.onCreateLoadedObjects ~= nil then		
				for k, onCreateObject in pairs(g_currentMission.onCreateLoadedObjects) do
					if onCreateObject.multiSiloTriggerDirtyFlag then
						local stationName = onCreateObject.stationName;						
						if stationName ~= nil then							
							if stationName == "Hofsilo" or stationName == "HofSiloLoad01" then								
								local fillTypes = getUserAttribute(onCreateObject.rootNode, "fillTypes");									
								if fillTypes == nil then
									fillTypes = getUserAttribute(onCreateObject.rootNode, "fruitTypes");
								end;			
								fillTypes = hofSiloLoadTypes
								fillTypesSplit = Utils.splitString(" ", fillTypes);			
								for _,v in pairs(fillTypesSplit) do
									local toInt = Fillable.fillTypeNameToInt[v];					
									if toInt ~= nil and onCreateObject.fillTypes[toInt] == nil then
										onCreateObject.fillTypes[toInt] = toInt;																
									end;					
								end;
							end;
						end;
					end;
				end;
			end;
		end;		
		local hofSilo01 = false;
		for k,tipTrigger in pairs(g_currentMission.tipTriggers) do			
			local stationName = getUserAttribute(tipTrigger.triggerId, "stationName");			
			if stationName ~= nil then
				local id = tipTrigger.triggerId;				
				local fillTypes = getUserAttribute(id, "fillTypes");
				local priceMultipliersString = getUserAttribute(id, "priceMultipliers");				
				if fillTypes == nil then
					fillTypes = getUserAttribute(id, "fruitTypes");
				end;
				if string.find(stationName, " ") then
					stationName = string.gsub(stationName, " ", "_");
				end;
				if isServer then					
					local textName = stationName;
					if g_i18n:hasText(stationName) then
						textName = g_i18n:getText(stationName);				
					end;
					if priceMultipliersString ~= nil then						
						print(stationNames.. stationName.. "(".. fillTypes.. ")".. priceMultipliersString.. "(InGame=".. tostring(textName).. ")" );						
					else						
						if fillTypes ~= nil then
							print(stationNames.. stationName.. "(".. fillTypes.. ") !!Warning!! Prices not found at station?");
						else
							print(stationNames.. stationName.. "(!!Warning!! FillTypes and prices not found at station?)");
						end;
					end;
				end;				
				if tipTrigger.priceMultipliers ~= nil or tipTrigger.acceptedFillTypes ~= nil then					
					local sellTypes = "";
					local sellPrices = 0;
					local deleteOldTypes = false;
					local pdaOn = "";
					local pdaOff = "";
					local sellMilk = true;
					local sellStopTypes = "";
					if isServer then
						if getXMLString(Xml, "Trigger.SellTrigger.".. stationName) ~= nil then
							TriggerExtendSellXml = TriggerExtendSellXml ..stationName .." " ..getXMLString(Xml, "Trigger.SellTrigger.".. stationName) ..";";						
							local foundSellTypes, foundSellPrices, foundSellStopTypes, foundDeleteOld, foundPDAOn, foundPDAOff, foundSellMilk = getSellTypes(tipTrigger, getXMLString(Xml, "Trigger.SellTrigger.".. stationName));
							if foundSellTypes ~= nil then
								sellTypes = foundSellTypes;
								sellPrices = foundSellPrices;
								deleteOldTypes = foundDeleteOld;
								pdaOn = foundPDAOn;
								pdaOff = foundPDAOff;
								sellMilk = foundSellMilk
								sellStopTypes = foundSellStopTypes;
							end;						
						end;
					end;
					if isClient and sellTriggerNew ~= nil then					
						if string.find(sellTriggerNew, stationName .." ") ~= nil then
							local serverTriggers = Utils.splitString(";", sellTriggerNew);							
							for k,v in pairs(serverTriggers) do
								if string.find(v, stationName) ~= nil then
									serverTriggers = string.gsub(v, stationName.. " ", "")
									local languageStationName = g_i18n:getText(tipTrigger.stationName)
									stationUpdateNames = stationUpdateNames.. " ".. languageStationName;
									break;
								end;
							end;
							local foundSellTypes, foundSellPrices, foundSellStopTypes, foundDeleteOld, foundPDAOn, foundPDAOff, foundSeelMilk = getSellTypes(tipTrigger, serverTriggers);
							if foundSellTypes ~= nil then
								sellTypes = foundSellTypes;
								sellPrices = foundSellPrices;
								deleteOldTypes = foundDeleteOld;
								pdaOn = foundPDAOn;
								pdaOff = foundPDAOff;
								sellStopTypes = foundSellStopTypes;
								if foundSeelMilk then clientSellMilk = true;end;
							end;						
						end;
					end;
					if deleteOldTypes then
						local types = Utils.splitString(" ", fillTypes);
						local multipliers = Utils.splitString(" ", priceMultipliersString);
						for k,v in pairs(types) do
							local desc = Fillable.fillTypeNameToDesc[v];
							if desc ~= nil then									
								tipTrigger.acceptedFillTypes[desc.index] = nil;
								tipTrigger.priceMultipliers[desc.index] = nil;
							end;
						end;
						if string.len(sellTypes) >= 2 then							
							fillTypes = sellTypes;
							if string.len(sellPrices) >= 2 and sellPrices ~= 0 then
								priceMultipliersString = sellPrices;
							end;
						end;
					else
						if string.len(sellTypes) >= 2 then							
							fillTypes = fillTypes.. " ".. sellTypes;
							if string.len(sellPrices) >= 2 and sellPrices ~= 0 then
								priceMultipliersString = priceMultipliersString.. " ".. sellPrices;
							end;
						end;
					end;											
					local types = Utils.splitString(" ", fillTypes);
					local multipliers = Utils.splitString(" ", priceMultipliersString);					
					sellTypes = sellTypes.. " ";					
					for k,v in pairs(types) do
						local desc = Fillable.fillTypeNameToDesc[v];
						if desc ~= nil and string.find(sellTypes, v.. " ") ~= nil then
							if tonumber(multipliers[k]) == 0 or string.find(sellStopTypes, v.. " ") ~= nil then
								tipTrigger.acceptedFillTypes[desc.index] = nil;
								tipTrigger.priceMultipliers[desc.index] = nil;
							else								
								tipTrigger.acceptedFillTypes[desc.index] = true;							
								local pricePerLiter = Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter;
								if tonumber(pricePerLiter) == 0 or pricePerLiter == nil then								
									Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter = tonumber(multipliers[k]);								
								end;							
								local previousHourPrice = Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice;
								if tonumber(previousHourPrice) == 0 or previousHourPrice == nil then								
									Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice = tonumber(multipliers[k])
								end;																
								--if desc.nameI18N == nil then
								--	desc.nameI18N = v.. "*";
								--else
								--	desc.nameI18N = v.. "*";
								--end;							
								--local hudOverlay = desc.hudOverlayFilename;
								--if hudOverlay ~= nil then
								--	print("Fix Error Hud Fremd Mod")								
								--end;
								local checkXMLValues = v.. ":".. tonumber(multipliers[k]);
								if string.find(changeType, v.. ":") == nil then
									--tipTrigger.priceMultipliers[desc.index] = 1;
									setChangeType(v, tonumber(multipliers[k]), false, false);
								else
									--if string.find(sellTypes, v.. " ") ~= nil then
									--	tipTrigger.priceMultipliers[desc.index] = 1;
									--else
									--	tipTrigger.priceMultipliers[desc.index] = tonumber(multipliers[k]);
									--end;
								end;
								tipTrigger.priceMultipliers[desc.index] = tonumber(multipliers[k]);
								if tipTrigger.priceMultipliers[desc.index] == nil then
									tipTrigger.priceMultipliers[desc.index] = Utils.getNoNil(tipTrigger.defaultPriceMultiplier, 1);								
									if not tipTrigger.isFarmTrigger and tipTrigger.defaultPriceMultiplier == nil then
										print("Error: "..k.."th priceMultiplier is invalid in TipTrigger "..getName(id));
									end;
								else
									--local fruitTypeDesc = FruitUtil.fruitTypes[v];
									--if fruitTypeDesc == nil or FruitUtil.registerFruitType(v) == nil or FruitUtil.registerFruitType(v) == false then
									--	if string.find(changeType, v.. ":") == nil then
											--setChangeType(v, tonumber(multipliers[k])+0.0000000000111, false, false);									
									--	end;
									--end;
								end;
							end;						
						end;						
					end;
					if isServer and not setSellMilk and not sellMilk then					
						setSellMilk = true;
					end;
					if string.len(pdaOn) >= 2 then
						local enable = Utils.splitString(",", pdaOn);						
						for k,v in pairs(enable) do
							if string.len(v) >= 2 then
								local desc = Fillable.fillTypeNameToDesc[v];
								if desc ~= nil and not Fillable.fillTypeIndexToDesc[desc.index].partOfEconomy then
									Fillable.addFillTypeToEconomy(Fillable.fillTypeNameToInt[v]);
									if v == "water" or  v == "fuel" then
										Fillable.fillTypeIndexToDesc[desc.index].notInStorage = true;
									end;
									if v == "silage" then
										Fillable.fillTypeIndexToDesc[desc.index].notInStorage = false;
									end;
									if v == "milk" then
										if not g_currentMission.missionDynamicInfo.isMultiplayer then
											amountPDA = true;											
										else
											Fillable.fillTypeIndexToDesc[desc.index].notInStorage = true;
										end;
									end;
								end;
							end;
						end;
					end;
					if string.len(pdaOff) >= 2 then
						local disable = Utils.splitString(",", pdaOff);
						for k,v in pairs(disable) do
							if string.len(v) >= 2 then
								local desc = Fillable.fillTypeNameToDesc[v];
								if desc ~= nil and Fillable.fillTypeIndexToDesc[desc.index].partOfEconomy then
									Fillable.fillTypeIndexToDesc[desc.index].partOfEconomy = false;
									--table.remove(Fillable.economyFillTypes, desc);
								end;
							end;
						end;
					end;
				end;
			end;
			if not hofSilo01 then
				local isAreaTrigger = Utils.getNoNil(getUserAttribute(tipTrigger.triggerId, "isAreaTrigger"), false);
				local isFarmTrigger = Utils.getNoNil(getUserAttribute(tipTrigger.triggerId, "isFarmTrigger"), false);			
				local siloName = getName(tipTrigger.triggerId);							
				if isFarmTrigger and isAreaTrigger and siloName ~= nil and siloName == "grainStationTrigger" then
					if tipTrigger.acceptedFillTypes ~= nil then																		
						local fillTypes = getUserAttribute(tipTrigger.triggerId, "fillTypes");									
						if fillTypes == nil then
							fillTypes = getUserAttribute(tipTrigger.triggerId, "fruitTypes");
						end;
						if string.find(fillTypes, "wheat ") ~= nil then							
							if isServer then
								if getXMLString(Xml, "Trigger.HofSiloTrigger.HofSiloUnLoad01") ~= nil then
									hofSiloUnLoadTypes = getXMLString(Xml, "Trigger.HofSiloTrigger.HofSiloUnLoad01")
									TriggerExtendSellXml = TriggerExtendSellXml .."HofSiloUnLoad01:" ..hofSiloUnLoadTypes ..";";
								end;
							end;
							if isClient and sellTriggerNew ~= nil then
								if string.find(sellTriggerNew, "HofSiloUnLoad01:") ~= nil then
									local serverTriggers = Utils.splitString(";", sellTriggerNew);							
									for k,v in pairs(serverTriggers) do
										if string.find(v, "HofSiloUnLoad01:") ~= nil then
											serverTriggers = string.gsub(v, "HofSiloUnLoad01:", "")										
											stationUpdateNames = stationUpdateNames.. " HofSiloUnLoad01";
											hofSiloUnLoadTypes = serverTriggers;
											break;
										end;
									end;
								end;
							end;
							fillTypes = fillTypes.. " ".. hofSiloUnLoadTypes
							local types = Utils.splitString(" ", fillTypes);
							for k,v in pairs(types) do
								local desc = Fillable.fillTypeNameToDesc[v];
								if desc ~= nil and tipTrigger.acceptedFillTypes[desc.index] == nil then
									tipTrigger.acceptedFillTypes[desc.index] = true;
									if v == "silage" then
										Fillable.fillTypeIndexToDesc[desc.index].notInStorage = false;
									end;
									if v == "milk" then										
										if not g_currentMission.missionDynamicInfo.isMultiplayer then
											amountPDA = true;
										else
											tipTrigger.acceptedFillTypes[desc.index] = nil;
										end;
									end;
								end;						
							end;							
							hofSilo01 = true;
						end;						
					end;					
				end;
			end;				
		end;
		if g_server ~= nil and g_client ~= nil then
			if string.len(hofSiloLoadTypes) >= 2 then
				print("set new HofSiloLoad01 fruits: ".. hofSiloLoadTypes)
			end;
			if string.len(hofSiloUnLoadTypes) >= 2 then
				print("set new HofSiloUnLoad01 fruits: ".. hofSiloUnLoadTypes)
			end;
			if setSellMilk then
				print("Automatic milk sell is disabled");
			end;
			print("Update TriggerExtend.......end")
		end;
		if g_server == nil then	
			--print("changeType.......".. changeType)		
			print("Server File Update TriggerExtend.......end")
		end;
	end;	
end;

function setChangeType(fillType, price, oldPrice, newChange)
	if newChange then
		local tempChangeType = string.gsub(changeType, fillType.. ":".. oldPrice, "");
		changeType = tempChangeType;
	end;
	changeType = changeType.. fillType.. ":".. price.. " ";	
end;
addModEventListener(TriggerExtend);

TriggerExtendEvent = {};
TriggerExtendEvent_mt = Class(TriggerExtendEvent, Event);
InitEventClass(TriggerExtendEvent, "TriggerExtendEvent");

function TriggerExtendEvent:emptyNew()    
	local self = Event:new(TriggerExtendEvent_mt );
    self.className="TriggerExtendEvent";
    return self;
end;

function TriggerExtendEvent:new(sellTriggerNew, noEventSend)    	
	local self = TriggerExtendEvent:emptyNew();
	self.setExtendTrigger = sellTriggerNew;	
	self.loginEvent = noEventSend;	
    return self;
end;

function TriggerExtendEvent:readStream(streamId, connection)    
	self.setExtendTrigger = streamReadString(streamId);  
    self.loginEvent = streamReadBool(streamId);	
	self:run(connection);
end;

function TriggerExtendEvent:writeStream(streamId, connection)    	
	streamWriteString(streamId, self.setExtendTrigger);
	streamWriteBool(streamId, self.loginEvent); 
end;

function TriggerExtendEvent:run(connection)
	if self.setExtendTrigger ~= nil and not self.loginEvent and not TriggerExtendMPUpdate then		
		self.setExtendTrigger = self.setExtendTrigger;		
		self:setExtendTriggersEvent(self.setExtendTrigger, true);		
	end;
	if self.loginEvent and not TriggerExtendMPUpdate then		
		self.setExtendTrigger = TriggerExtendSellXml;
		TriggerExtendEvent.sendEvent(self.setExtendTrigger, false)	
	end;
end;

function TriggerExtendEvent.sendEvent(sellTriggerNew, noEventSend)		
	if g_server ~= nil and g_server ~= false and not noEventSend then		
		g_server:broadcastEvent(TriggerExtendEvent:new(sellTriggerNew, false), nil, nil, nil);		
	end;
	if g_server == nil and noEventSend then		
		g_client:getServerConnection():sendEvent(TriggerExtendEvent:new(sellTriggerNew, true));
	end;
end;

function TriggerExtendEvent:setExtendTriggersEvent(sellTriggerNew, noEventSend)	
	if sellTriggerNew ~= nil then		
		synSellTriggers(false, true, sellTriggerNew)
		TriggerExtendMPUpdate = true;
		if g_currentMission.modMultiOverlayUpdate ~= nil then g_currentMission.modMultiOverlayUpdate = true;end;
		if clientSellMilk and g_currentMission.triggerExtendSellMilk == nil then g_currentMission.triggerExtendSellMilk = true;end;
		g_currentMission.inGameMessage:showMessage("TriggerExtend", "update Triggers:\n".. stationUpdateNames, 5000, false);				
	end;
end;

--Savegame made by HappLooser...siehe TriggerExtendLoad()--
function saveBackup(file, path)
	if g_server == nil and g_dedicatedServerInfo == nil then return end;
	local fileBackup = path.."/savegameBackup/triggerExtendSettings.xml";	
	copyFile(file, fileBackup);
end;

local function getXMLBack(self)	
	if g_server == nil and g_dedicatedServerInfo == nil then return end;
	local path = getUserProfileAppPath();
	local fileBackup = path.."/savegameBackup/triggerExtendSettings.xml";
	local file = pathSavegame.."/triggerExtendSettings.xml";
	if fileExists(pathSavegame.. "/careerSavegame.xml") and fileExists(fileBackup) then
		copyFile(fileBackup, file);
	end;
end;
g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, getXMLBack);
--Savegame made by HappLooser...siehe TriggerExtendLoad()--